unit FileHandlingU;

interface
uses
  sysutils,
  classes;

var
  IncludePaths : TStringlist;
  SearchPaths : TStringlist;

Function FindFile(const Filename : string) : string;
function Loadfile(const Filename : string) : TStringList;

Procedure ReadSemiColonDelimitedList(s : string; list : TStringlist);

implementation

function Loadfile(const Filename : string) : TStringList;
var ErrorAddress : Pointer;
begin
if not FileExists( Filename ) then
  begin
  asm
    MOV eax,[EBP+4];
    MOV ErrorAddress,eax;
  end;
  raise Exception.createfmt('Unable to find "%s"',[ExtractFileName(Filename)]) at ErrorAddress;  
  end;
Result := TStringList.create;
try
  Result.LoadFromFile( Filename );
except
  Result.free;
  asm
    MOV eax,[EBP+4];
    MOV ErrorAddress,eax;
  end;
  raise Exception.createfmt('Unable to find "%s"',[ExtractFileName(Filename)]) at ErrorAddress;
end;
end; {Loadfile}

Function FindFile(const Filename : string) : String;

var
  index : integer;
  tmp : string;
begin
result := Filename;
if FileExists( Filename ) then exit;
for index := 0 to SearchPaths.count -1 do
  begin
  tmp := IncludeTrailingBackslash(SearchPaths[index])+Filename;
  if FileExists(tmp) then
    begin
    result := tmp ;
    exit;
    end;
  end;
for index := 0 to IncludePaths.count -1 do
  begin
  tmp := IncludeTrailingBackslash(IncludePaths[index])+Filename;
  if FileExists(tmp) then
    begin
    result := tmp;
    exit;
    end;
  end;
end; {FindFile}

Procedure ReadSemiColonDelimitedList(s : string; list : TStringlist);
var
  SubStr : string;
  MarkerPos : integer;
begin
assert(list <> nil);
While s <> '' do
  begin
  MarkerPos := AnsiPos(';',s);
  if MarkerPos <> 0 then
    begin
    SubStr := copy(s,1,MarkerPos-1);
    Delete(s,1,MarkerPos);
    end
  else
    begin
    SubStr := s;
    s := '';
    end;
//  list.add(ExtractRelativePath(ExtractFilePath(Application.ExeName),SubStr));
  list.add( SubStr );
  end;
end; {ReadSemiColonDelimitedList}

end.
